﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Converter : MonoBehaviour {
	
	public static Converter Instance = null; // rende la classe un singleton
	private Text daConvertire;
	private int baseDiPartenza;  
	private GameObject doveTesto;
	[SerializeField] private GameObject base10, base2, base8, base16, base20; // dichiarazione delle diverse tastiere 

	void Awake () {
		Instance = this; // viere restituito l'oggetto instance
	}

	public string to10perCalcoli(string stringa, int basePartenza){
		//questa funzione viene utilizzata per convertire i numeri in base 10 nelle operazioni aritmetiche.
		string somma = "0"; // inizializzo il totale a 0
		for (int i = 0; i < stringa.Length; i++) { // ciclo che legge la stringa in input
			somma = Operation.Instance.addizione(10, somma, "" + Char_Converter.Instance.convertCharToInt //aggiungo alla somma:
				(stringa [stringa.Length-(i+1)])*Mathf.Pow(basePartenza,i)); //il risultato del prodotto tra cifra e base elevata per la posizione della cifra
		}
		return somma; //viene restituito il numero convertito in base 10.
	}

	public string to10(string stringa, int basePartenza){
		// questa funzione converte un numero in base 10, non è utilizzabile per le operazioni aritmetiche
		// perche vengono utilizzate in questa funzione per operare su numeri eccessivamente grandi. Dato che alcune operazioni
		// hanno bisogno di un numero convertito in base 10, si genererebbe un loop infinito.
		string somma = "0"; // inizializzo la somma a 0
		for (int i = 0; i < stringa.Length; i++) { // ciclo che legge la stringa in input
			somma = Operation.Instance.addizione (10, somma, Operation.Instance.moltiplicazioneInColonna // si aggiunge alla somma:
				(10, "" + stringa [stringa.Length - (i + 1)], Operation.Instance.potenza(10, "" + basePartenza ,"" + i))); // il prodotto tra cifra e il risultato della potenza
		}
		return somma; //viene restituito il numero convertito in base 10.
	}

	public string from10perCalcoli(string stringa, int baseObiettivo , int basePartenza){

		int numIn10 = int.Parse (to10perCalcoli (stringa, basePartenza)); // converto ad intero la stringa in input convertita in base 10
		string totale = ""; // inizializzo il totale come stringa vuota
		while (numIn10 >=1) { //finché il numero è maggiore o uguale di 1:
			totale = Char_Converter.Instance.convertIntToChar (numIn10 % baseObiettivo) + totale; // aggiungo all'inizio della stringa il resto della divisione tra numero e baseObiettivo
			numIn10 /= baseObiettivo; // divido il numIn10 per la baseObiettivo
		}
		return totale == "" ? "0" : totale; // restituisco il totale, se la stringa è vuota, restituisco 0
	}

	public string from10(string stringa, int baseObiettivo , int basePartenza){
		string numIn10 = to10 (stringa, basePartenza); // converto la stringa in input in base 10
		string totale = ""; // inizializzo il totale come stringa vuota
		while (numIn10 != "0") { // finché la stringa è diversa da "0":
			totale = Char_Converter.Instance.convertIntToChar(int.Parse(Operation.Instance.modulo(10, numIn10, "" + baseObiettivo))) + totale; // il numIn10 e la baseObiettivo, in poche parole il modulo tra numIn10 e la baseObiettivo
			numIn10 = Operation.Instance.divisioneInColonna (10, numIn10, "" + baseObiettivo); // divido il numIn10 per la baseObiettivo
		}
		return totale == "" ? "0" : totale; // restituisco il totale, se la stringa è vuota, restituisco 0
	}


	public void convert(){
		//funzione chiamata quando viene premuto il tasto "Convert!"
		base10.GetComponent<InputField> ().text = "" + to10 (daConvertire.text, baseDiPartenza); // scrive sulla textbox della base 10 il risultato
		base2.GetComponent<InputField> ().text = "" + from10 (daConvertire.text, 2, baseDiPartenza); // scrive sulla textbox della base 2 il risultato
		base8.GetComponent<InputField> ().text = "" + from10 (daConvertire.text, 8, baseDiPartenza); // scrive sulla textbox della base 8 il risultato
		base16.GetComponent<InputField> ().text = "" + from10 (daConvertire.text, 16, baseDiPartenza); // scrive sulla textbox della base 16 il risultato
		base20.GetComponent<InputField> ().text = "" + from10 (daConvertire.text, 20, baseDiPartenza); // scrive sulla textbox della base 20 il risultato
	}



	public void setDaConvertire(Text x ){
		daConvertire = x; // setta la stringa da convertire, viene chiamata quando viene scritta una stringa in una textbox
	}

	public void setBaseDiPartenza(int x){
		baseDiPartenza = x; // setta la base numerica della stringa da convertire, viene chiamata quando viene scritta una stringa in una textbox
	}

	public void setDoveTesto(GameObject casella){
		doveTesto = casella; // setta la textbox dove devono essere scritti i caratteri
		casella.GetComponent<InputField> ().text = ""; // cancella il contenuto della textbox
		TouchScreenKeyboard keyboard = TouchScreenKeyboard.Open ("", TouchScreenKeyboardType.Default, false, false, false); //chiude la tastiera integrata di android
		keyboard.active = false;
	}

	public void scriviSuTesto(string lettera){
		if (doveTesto.GetComponent<InputField> ().text.Length < 15)
			doveTesto.GetComponent<InputField> ().text += lettera;// inserisce nella textbox il carattere corrispondente al tasto
	}

	public void cancellaSuTesto(){
		if (doveTesto.GetComponent<InputField> ().text.Length > 0) //se il numero di caratteri presenti nella textbox è maggiore di 0:
			doveTesto.GetComponent<InputField> ().text = 
				doveTesto.GetComponent<InputField> ().text.Remove (doveTesto.GetComponent<InputField> ().text.Length - 1); //cancella il primo carattere a destra
	}
}
