﻿
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using System.Text;


public class Operation : MonoBehaviour {
	public static Operation Instance = null;// rende la classe un singleton
	private GameObject doveTesto;
	[SerializeField] private Dropdown selectBase; 
	[SerializeField] private Dropdown selectOperation;
	[SerializeField] private Text tot;
	[SerializeField] private InputField primo, secondo;

	void Awake(){
		Instance = this; // viere restituito l'oggetto instance
		if (Cambia_Scena.Instance.getScene () == "Operations") {//controlla se siamo sulla scena "Operations"
			setDoveTesto (primo.gameObject);//setta la prima casella
			selectOperation.value = 0;//setta l'operazione di addizione 
			selectBase.value = 0;//setta la base 10
		}
	}

	public string addizione (int baseObiettivo, string num1, string num2) {//funzione che fa l'addizione
		equalizeArray (ref num1, ref num2);//si equalizzano le due stringhe
		string totale = "";//si setta il totale come stringa vuota
		int riporto = 0, somma = 0;
		for (int i = (num1.Length - 1); i >= 0; i--) {//ciclo che partendo dall'ultimo carattere lo somma con l'ultimo della seconda stringa
			somma = 0;//si inizializza la variabile somma a zero
			//si somma il carattere della prima con quello della seconda stringa e si sommano gli eventuali riporti calcolati nel giro del ciclo prima
			somma = ((Char_Converter.Instance.convertCharToInt(num1 [i])) + Char_Converter.Instance.convertCharToInt(num2 [i]) + riporto) % baseObiettivo;
			//si calcolano se ci sono i riporti venuti dalla somma dei due caratteri delle stringhe
			riporto = ((Char_Converter.Instance.convertCharToInt(num1 [i])) + Char_Converter.Instance.convertCharToInt(num2 [i]) + riporto) / baseObiettivo;
			//si controlla se il ciclo è alla fine e se c'è il riporto
			//se c'è allora alla stringa del totale si mette il riporto, la conversione da intero a carattere della somma e il totale del ciclo prima 
			if (i==0 && riporto != 0) totale = "" + riporto + Char_Converter.Instance.convertIntToChar(somma) + totale; 
			//altrimenti si mette soltanto la conversione da intero a carattere della somma e il totale del ciclo prima senza il riporto
			else totale = "" + Char_Converter.Instance.convertIntToChar(somma) + totale;
		}
		return togliZeriIniziali(totale); //la funzione ritorna il totale togliendo gli eventuali zeri iniziali
	}

	public string sottrazione (int baseObiettivo, string num1, string num2){//funzione per effettuare la sottrazione
		equalizeArray (ref num1, ref num2);//equalizza gli array
		string totale = "";//si setta il totale come stringa vuota
		int[] arrayPrestiti = new int[num1.Length];//si istanzia un array per i prestiti di lunghezza pari a quella della prima stringa
		int sott = 0; // dichiariamo e inizializziamo la variabile sott a 0
		for (int i = (num1.Length - 1); i >= 0; i--) { //...
			//ciclo che partendo dall'ultimo valore del minuendo lo sottrae all'ultimo del sottraendo e man mano si continua fino al primo valore 
			sott = 0; // la variabile sotto prende 0
			if ((Char_Converter.Instance.convertCharToInt (num1 [i])+ arrayPrestiti[i]) < Char_Converter.Instance.convertCharToInt (num2 [i])) { //...
				//Se il valore del minuendo è inferiore al valore del sottraendo (entriamo dentro l'IF) e viene presa un eventuale unità dal valore subito a sinistra   
				int pos = i; // inizializziamo e settiamo la variabile pos a i;
				bool trovato = false; // Inizializziamo e settiamo la variabile trovato a false
				while (pos-- >= 0 && !trovato) { //ciclo per scorrere i valori del minuendo verso sinistra alla ricerca di un unità
					if (pos < 0) //Nel caso non è stato trovato un unità nel minuendo significa che il sottraendo è maggiore del minuendo 
						return "Underflow!"; // restituiamo underflow 
					if (Char_Converter.Instance.convertCharToInt (num1 [pos])+ arrayPrestiti[pos] > 0) {//troviamo un valore disponibile per la cessazione di un'unità
						trovato = true; // la variabile booleana trovato diventa true
						int indiceRitorno = pos; // inizializziamo e settiamo la variabile indiceRitorno a pos 
						while (indiceRitorno < i) { // ciclo per sottrarre un' unità al valore disponibile nel minuendo e settare tutti gli eventuali 0 al
							// valore della base per cui stiamo sottraendo
							arrayPrestiti [indiceRitorno] -= 1; //sottraiamo 1 al valore che ci presta un'unità
							arrayPrestiti [indiceRitorno + 1] += baseObiettivo; // settiamo gli eventuali '0' del minuendo al valore della base
							indiceRitorno++; // la variabile "indiceRitorno" incrementa di 1
						}
					}
				}
			}
			sott = Char_Converter.Instance.convertCharToInt (num1 [i]) - Char_Converter.Instance.convertCharToInt (num2 [i]) + arrayPrestiti [i]; //...
			// viene effettuata la sottrazione tra il valore del minuendo e il valore del sottraendo corrispondente
			arrayPrestiti [i] = 0; // settiamo il vettore con indice 'i' a 0 in modo da poterlo riutilizzare al prossimo ciclo
			totale = "" + Char_Converter.Instance.convertIntToChar (sott) + totale; // la variabile totale prende il risultato della sottrazione 
		}
		return togliZeriIniziali(totale); //la funzione ritorna il totale togliendo gli eventuali zeri iniziali
	}

	string moltiplicazione (int baseObiettivo, string num1, string num2){
		int numeroMoltiplicazione = int.Parse(Converter.Instance.to10perCalcoli (num2, baseObiettivo)); // la variabile numeroMoltiplicazione prende il valore 
		// di num2 convertito in intero
		string totale = "0"; // dichiarazione e inizializzazione variabile "totale" con 0
		for (int i = 0; i < numeroMoltiplicazione; i++) { // ciclo che ad ogni iterazione somma num1 alla variabile totale per "numeroMoltiplicazione" volte
			totale = addizione (baseObiettivo, totale, num1); // viene richiamata la funzione addizione
		}
		return totale; //ritorna il risultato della moltiplicazione
	}

	public string moltiplicazioneInColonna (int baseObiettivo, string num1, string num2){
		string totale = "0"; // dichiariamo e inizializziamo totale a "0"
		string[] arrayMoltiplicazioni = new string[num2.Length]; //dichiariamo dinamicamente e inizializziamo arrayMoltiplicazioni alla lunghezza del moltiplicatore
		for (int a = 0; a < num2.Length; a++) // ciclo per settare "0" al vettore arrayMoltiplicazioni per ogni indice da zero alla lunghezza del moltiplicatore 
			arrayMoltiplicazioni [a] = "0"; // settiamo "0" ad arrayMoltiplicazioni[a]
		for (int i = num2.Length - 1; i >= 0; i--) { // ciclo per scorrere i valori del moltiplicatore
			for (int j = num1.Length - 1; j >= 0; j--) { // ciclo per scorrere i valori del moltiplicando
				string mol = moltiplicazione (baseObiettivo, "" + num1 [j], "" + num2 [i]); // viene richiamata la funzione moltiplicazione che restituisce ... 
				// il risultato e lo immagazzina nella variabile mol
				for (int k = 0; k < (num1.Length - 1 - j); k++) 
					mol += "0"; // aggiungiamo "0" alla stringa mol
				arrayMoltiplicazioni [i] = addizione (baseObiettivo, arrayMoltiplicazioni [i], mol); //viene richimata la funzione addizione che somma i risultati ...
				// del singolo valore del moltiplicatore per tutti i valori del moltiplicando e la somma viene messa nel vettore "arrayMoltiplicazione[i]"
			}
			for (int b = 0; b < (num2.Length - 1 - i); b++) //ciclo per aggiungere "0" al valore corrispondente del vettore "arrayMoltiplicazioni[i]" 
				//in modo da porter allineare i vari valori per poi fare la somma come nella motiplicazione classica in colonna
				arrayMoltiplicazioni [i] += "0"; // aggiungiamo "0" 
			// allineare i vari valori per poi fare la somma come nella motiplicazione classica in colonna
			totale = addizione (baseObiettivo, totale, arrayMoltiplicazioni [i]); // "totale" nell'ultimo ciclo prende il risultato della moltiplicazione 
		}
		return totale; // restituisce il risultato della moltiplicazione
	}

	string divisione (int baseObiettivo, string num1, string num2){
		int numeroDivisione = 0; // inizializzo numeroDivisione a 0, tiene conto del risultato del quoziente
		while (sottrazione (baseObiettivo, num1, num2) != "Underflow!") { // finché num1 è >= num2
			num1 = sottrazione (baseObiettivo, num1, num2);  // num1 = num1 - num2
			numeroDivisione++; 
		}
		// restituisco il quoziente convertito nella base numerica desiderata partendo dalla 10
		return Converter.Instance.from10perCalcoli ("" + numeroDivisione, baseObiettivo, 10); 
	}

	public string divisioneInColonna(int baseObiettivo, string num1, string num2){
		if (Converter.Instance.to10perCalcoli (num2, baseObiettivo) == "0") // se il divisore è uguale a 0
			return "Impossible"; // la divisione è impossibile
		int lunghezzaStringa = num1.Length;
		string tmp = "", quoziente = "";
		for (int i = 0; i < lunghezzaStringa; i++) { // legge il dividendo
			tmp += num1 [i]; //inserisco una cifra del dividendo da sinistra a tmp
			if (sottrazione (baseObiettivo, tmp, num2) != "Underflow!") { // se tmp è >= al divisore
				string ris = divisione (baseObiettivo, tmp, num2); // risultato di tmp / divisore
				quoziente += ris; // aggiungo ris a destra del quoziente
				tmp = sottrazione(baseObiettivo, tmp, moltiplicazione(baseObiettivo, num2, ris)); // sottraggo a tmp il divisore moltiplicato per ris
			}
			else quoziente += "0"; // altrimenti aggiungo uno 0 a destra del quoziente
		}
		return togliZeriIniziali (quoziente);  // restituisco il quoziente senza eventuali zeri all'inizio

	}
	public string potenza(int baseObiettivo, string numero, string esponente){
		if (numero == "1")
			return "1"; // se il numero base è 1 restituisco 1
		if (numero == "0" && esponente == "0")
			return "???"; // restituisco indefinito
		string ris = "1"; //inizializzo il risultato ad 1
		for (int i = 0; i < int.Parse(Converter.Instance.to10perCalcoli (esponente, baseObiettivo)); i++) {
			ris = moltiplicazioneInColonna (baseObiettivo, ris, numero); // sommo a ris il prodotto tra ris e numero
			if ((baseObiettivo == 2 && ris.Length > 64) || (baseObiettivo != 2 && ris.Length > 20))
				return "Number too high!"; // se il risultato in base 2 ha piu di 64 cifre o per tutte le altre basi piu di 20 cifre
		}
		return ris;
	}

	public string modulo(int baseObiettivo, string num1, string num2){
		// si restituisce il risultato di num1 - (num2 * (num1 / num2)) 
		return Operation.Instance.sottrazione(baseObiettivo, num1 ,
			Operation.Instance.moltiplicazioneInColonna(baseObiettivo, num2,
				Operation.Instance.divisioneInColonna(baseObiettivo, num1, num2)));
	}


	string togliZeriIniziali(string stringa){//funzione che elimina gli zeri iniziali 
		int zeriDaTogliere = 0;
		for (int i = 0; i < stringa.Length - 1; i++) {//ciclo che conta quanti sono gli zeri iniziali di una stringa
			if (Char_Converter.Instance.convertCharToInt (stringa [i]) == 0)//converte i caratteri in interi e controlla se sono 0
				//se sono 0 incrementa una variabile che conta gli zeri
				zeriDaTogliere++;
			//altrimenti esce dal ciclo
			else
				break;
		}
		//a fine ciclo: 
		return stringa.Remove (0, zeriDaTogliere);//si usa questa funzione che rimuove dalla posizione 0 della stringa un numero di zeri pari al valore della variabili zeriDaTogliere
	}
		

	public int getBase(){//funzione che imposta la base su "selectBase"
		switch (selectBase.value) {//se si prende 
		case 0://0 base 10
			return 10;
		case 1://1 base 2
			return 2;
		case 2://2 base 8
			return 8;
		case 3://3 base 16
			return 16;
		case 4://4 base 20
			return 20;
		}
		return 10;//in tutti altri casi la base è la 10
	}

	public char getOperation(){//funzione per impostare l'operazione da fare 
		switch (selectOperation.value) {//se si prende il valore:
		case 0://0 è addizione
			return '+';
		case 1: //1 è sottrazione
			return '-';
		case 2: //2 è moltiplicazione
			return '*';
		case 3: //3 è divisione
			return '/';
		case 4: //4 è potenza
			return '^';
		case 5: //5 è modulo
			return '%';
		}
		return 'e';//qualsiasi altro valore non corrisponde a nessuna operazione
	}

	public void calcola(){//funzione che viene chiamata quando si clicca il pulsante "Calcola"
		switch (getOperation ()) {//si sceglie l'operazione da effettuare
		case '+'://caso addizione
			//chiama la funzione "stampaTotale()" che prende come parametro la funzione "addizione()" spiegata sopra
			stampaTotale (addizione (getBase (), primo.text, secondo.text));
			break;
		case '-'://caso sottrazione
			//chiama la funzione "stampaTotale()" che prende come parametro la funzione "sottrazione()" spiegata sopra
			stampaTotale (sottrazione (getBase (), primo.text, secondo.text));
			break;
		case '*'://caso moltiplicazione
			//chiama la funzione "stampaTotale()" che prende come parametro la funzione "moltiplicazioneInColonna()" spiegata sopra
			stampaTotale (moltiplicazioneInColonna (getBase (), primo.text, secondo.text));
			break;
		case '/'://caso divisione
			//chiama la funzione "stampaTotale()" che prende come parametro la funzione "divisioneInColonna()" spiegata sopra
			stampaTotale (divisioneInColonna (getBase (), primo.text, secondo.text));
			break;
		case '^'://caso potenza
			//chiama la funzione "stampaTotale()" che prende come parametro la funzione "potenza()" spiegata sopra
			stampaTotale (potenza (getBase (), primo.text, secondo.text));
			break;
		case '%'://caso potenza
			//chiama la funzione "stampaTotale()" che prende come parametro la funzione "modulo()" spiegata sopra
			stampaTotale (modulo (getBase (), primo.text, secondo.text));
			break;
		}

	}

	void equalizeArray(ref string stringa1, ref string stringa2){//funzione che equalizza la lunghezza delle stringhe
		int differenza = 0;
		int lunghezza1 = stringa1.Length;//si prende la lunghezza della prima stringa
		int lunghezza2 = stringa2.Length;//si prende la lunghezza della seconda stringa
		if (lunghezza1 > lunghezza2){//se la prima stringa è quella piu lunga
			differenza = lunghezza1 - lunghezza2; //si salva la differenza in una variabile 
			for (int i=0;i < differenza; i++)  stringa2 = '0' + stringa2;//ciclo che aggiunge alla seconda stringa un numero di zeri pari alla differenza 
		} else if (lunghezza2 > lunghezza1){//altrimenti se la seconda stringa è quella più lunga
			differenza = lunghezza2 - lunghezza1; //si salva la differenza in una variabile 
			for (int i=0;i < differenza; i++)	stringa1 = '0' + stringa1;////ciclo che aggiunge alla prima stringa un numero di zeri pari alla differenza
		}
	}

	void stampaTotale(string totale){
		tot.text = totale; // scrive il totale dell'operazione
	}

	public void cancellaCaselle(){//funzione che cancella il contenuto delle caselle
		primo.text = secondo.text = "";//quando si clicca su una casella si cancella il contenuto 
	}

	public void setDoveTesto(GameObject casella){//funzione che setta la text box dove scrivere
		doveTesto = casella;
		casella.GetComponent<InputField> ().text = "";//imposta la text box come stringa vuota
		//si disattiva la tastiera di default Android
		TouchScreenKeyboard keyboard = TouchScreenKeyboard.Open ("", TouchScreenKeyboardType.Default, false, false, false);
		keyboard.active = false;
	}

	public void scriviSuTesto(string lettera){//funzione per la scrittura sulle text box
		if (doveTesto.GetComponent<InputField> ().text.Length < 15)
			doveTesto.GetComponent<InputField> ().text += lettera;//aggiunge un carattere alla text box 
	}

	public void cancellaSuTesto(){//funzione per cancellare su i caratteri con il pulsante backspace
		if (doveTesto.GetComponent<InputField> ().text.Length > 0)//controlla se nella casella ci sono dei caratteri
			//rimuove l'ultimo carattere riducendo la lunghezza della stringa di 1
			doveTesto.GetComponent<InputField> ().text = doveTesto.GetComponent<InputField> ().text.Remove (doveTesto.GetComponent<InputField> ().text.Length - 1);
	}
}


