﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Canvas_Manager : MonoBehaviour {
	public static Canvas_Manager Instance = null; // dichiarazione della funzione Istance per rendere la classe Canvas_Manager static
	private bool indietro = false; //gestisce il tasto backspace delle tastiere
	[SerializeField] private Canvas tastiera10, tastiera2, tastiera8, tastiera16, tastiera20, principale; //dichiarazione di ogni tastiera 
	// Use this for initialization
	void Awake () {
		Instance = this; //istanziata la funzione Istance
	}



	
	public void canvasAppear(Canvas canvas){ //fa apparire la tastiera passata come parametro
		allCanvasDisappear (); //disattiva tutte le tastiere
		if (!indietro) { 
			indietro = true;
			canvasAppear (principale);//fa apparire il pulsante backspace
		}
		canvas.GetComponent<CanvasGroup> ().alpha = 1f; //rende la tastiera visibile
		canvas.GetComponent<CanvasGroup> ().interactable = true;
		canvas.GetComponent<CanvasGroup> ().blocksRaycasts = true;
	}

	public void canvasAppear(){
		int numero = Operation.Instance.getBase (); //assegna alla variabile numero la base su cui stiamo operando prendendola dalla funzione getBase() della classe "Operation"
		Canvas canvas = getTastiera(numero); //l'oggetto canvas prende la tastiera tramite la funzione getTastiera spiegata in fondo
		allCanvasDisappear (); //vengono disattivate tutte le tastiere
		if (!indietro) {
			indietro = true;
			canvasAppear (principale); //fa apparire il pulsante backspace
		}
		canvas.GetComponent<CanvasGroup> ().alpha = 1f; //rende la tastiera visibile
		canvas.GetComponent<CanvasGroup> ().interactable = true;
		canvas.GetComponent<CanvasGroup> ().blocksRaycasts = true;
	}

	void allCanvasDisappear(){ // disattiva tutte le tastiere
		canvasDisappear (tastiera10); //10
		canvasDisappear (tastiera2); //2
		canvasDisappear (tastiera8); //8
		canvasDisappear (tastiera16); //16
		canvasDisappear (tastiera20); //20
	}

	void canvasDisappear(Canvas canvas){//quando le tastiere sono disabilitate:
		canvas.GetComponent<CanvasGroup> ().alpha = 0f;//le rende invisibili
		canvas.GetComponent<CanvasGroup> ().interactable = false;
		canvas.GetComponent<CanvasGroup> ().blocksRaycasts = false;
	}

	Canvas getTastiera(int numero){//il parametro numero prende gli interi "10,2,8,16,20" 
		switch (numero) { //a ogni dei 5 interi presi da numero associamo una tastiera
		case 10:
			return tastiera10; //10
		case 2:
			return tastiera2; //2
		case 8:
			return tastiera8; //8
		case 16:
			return tastiera16; //16
		case 20: 
			return tastiera20; //20
		}
		return null; //prende null se l'intero preso non rientra nei casi visti in precedenza
	}
}
